/*
 * Copyright (c) 2000 S.Eguchi(fukurou@kissa.ne.jp)
 * All rights reserved.
 */
#include <stdio.h> 
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <strings.h>
#include <sys/stat.h>

#include "Conf.h"
#include "GblArea.h"

typedef struct tConfGlobal {
	char*	tagName;
	char*	globalStr;
	int		globalStrLength;
} ConfGlobal;

static ConfGlobal gConfGlobal[] = {
	{ "WU_NUM",    			  gConfWUNum              ,sizeof(gConfWUNum) },
	{ "SETI_PARAM",           gConfSetiParm           ,sizeof(gConfSetiParm) },
	{ NULL,                   NULL                    ,0 },
};


int ConfInit()
{
	FILE*		confFileFp;
	char*		getRet;
	ConfGlobal*	confArrP;
	char*		tagString;
	char*		valueString;
	char		searchFlag;
	int			lineNumber;
	struct stat fileStat;
	char		envGetBuffer[1024];


	confArrP = gConfGlobal;
	while(confArrP->tagName != NULL) { 
		bzero(confArrP->globalStr, confArrP->globalStrLength);
		confArrP++;
	}

	if(stat(CONFFILENAME, &fileStat) != 0) {
		sprintf(g_msgWork, "Warnning! not specify configuration file(%s)", 
						CONFFILENAME);
		LOGOUT(g_msgWork);
		return(0);
	}

	confFileFp = fopen(CONFFILENAME, "r");
	if(confFileFp ==NULL) {
		return(0);
	}

	lineNumber=0;
	for(;;) {
		bzero(envGetBuffer, sizeof(envGetBuffer));
		getRet = fgets(envGetBuffer, sizeof(envGetBuffer), confFileFp);
		if(getRet == NULL) { 
			if (ferror(confFileFp)) { 
				fclose(confFileFp); 
				return(-1);
			}
			else {
				break;
			}
		}
		lineNumber++;
		envGetBuffer[strlen(envGetBuffer)-1]='\0';

		if(envGetBuffer[0] == CONFFILE_COMMENT) { 
			continue;
		}

		tagString =strtok(envGetBuffer, CONFFILE_DELIMITER); 
		if(tagString == NULL) { 
			continue;
		}
		valueString=strtok(NULL, CONFFILE_DELIMITER);

		confArrP = gConfGlobal;
		searchFlag = '0';
		while(confArrP->tagName != NULL) { 
			if(strcmp(confArrP->tagName, tagString) == 0) { 
				strcpy(confArrP->globalStr, valueString);
				searchFlag = '1';
				break;
			}
			confArrP++;
		}
		if(searchFlag == '0') { 
			sprintf(g_msgWork, "Warnning! unknown tag %s in %s", 
							tagString,CONFFILENAME);
			LOGOUT(g_msgWork);
		}
	
	}
	fclose(confFileFp);
	return(0);
}

