/*
 * Copyright (c) 2000 S.Eguchi(fukurou@kissa.ne.jp)
 * All rights reserved.
 */
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

#include "GetWUDirStatus.h"
#include "Log.h"
#include "GblArea.h"


WU_DIR_STAT GetWUDirStat(char* dir)
{
	struct stat fileStat;
	char		filename[1024];
	
	/* check specifyed directory */
	if(stat(dir, &fileStat) != 0) {
		DBGOUT(dir);
		return(WU_DIR_STAT_ERR);
	}
	if( !(S_ISDIR(fileStat.st_mode)) ) { 
		DBGOUT("NO DIR");
		return(WU_DIR_STAT_NO_DIR);
	}

	/* Is there result file? */
	strcpy(filename, dir);
	strcat(filename, "/");
	strcat(filename, g_wuResult);
	if(stat(filename, &fileStat) == 0) {
		DBGOUT(filename);
		return(WU_DIR_STAT_END);
	}

	/* Is there working unit file? */
	strcpy(filename, dir);
	strcat(filename, "/");
	strcat(filename, g_wuFilename);
	if(stat(filename, &fileStat) != 0) {
		DBGOUT(filename);
		return(WU_DIR_STAT_NO_WU);
	}

	return(WU_DIR_STAT_EXECUTION);
}

char* GetWUDirStatString(WU_DIR_STAT stat)
{
	switch(stat) {
    case WU_DIR_STAT_END: 		
		return("working unit is ended");break;
    case WU_DIR_STAT_EXECUTION: 
		return("executing other setiathome ");break;
    case WU_DIR_STAT_NO_WU:     
		return("not found working unit ");break;
    case WU_DIR_STAT_NO_DIR:    
		return("not found spcify directory ");break;
    case WU_DIR_STAT_ERR:       
		return("error detect  ");break;
	}
	return("");
}

time_t GetWUModifyTime(char* dir)
{
	struct stat fileStat;
	char		filename[1024];

	strcpy(filename, dir);
	strcat(filename, "/");
	strcat(filename, g_wuFilename);
	if(stat(filename, &fileStat) != 0) {
		DBGOUT(filename);
		return(0);
	}
	return((long)fileStat.st_mtime);
}

