/*
 * Copyright (c) 2000 S.Eguchi(fukurou@kissa.ne.jp)
 * All rights reserved.
 */
#include <stdio.h>
#include <time.h>
#include <sys/file.h>
#include <errno.h>
#include "Log.h"


void LogoutProc(char* filename, int line, char* addmsg)
{
	int		fd;
	int		t;
	struct tm*  lt;
	char	buff[256];
	int		i;

	t=time(0);
	lt=localtime((const time_t *)&t);

	/* log file open */
	fd=open(LOGFILE, O_WRONLY|O_CREAT|O_APPEND, 0666);
	if(fd<0)  {
		return;
	}

	/* logfile locking */
	i=0;
	for(;;) {	
		i++;
		if(i>LOG_LOCK_RETRY_MAX) {
           	close(fd);
			return;
		}
    	if(flock(fd, LOCK_EX|LOCK_NB) == 0) {
			break;
		}
		else {
        	if(errno == EWOULDBLOCK) {
				sleep(1);
				continue;
        	}
        	else {
            	close(fd);
				return;
        	}
		}
	}
			 

	if(filename == 0) {
		sprintf(buff,"%04d/%02d/%02d %02d:%02d:%02d : %s\n", 
			lt->tm_year+1900,lt->tm_mon+1,lt->tm_mday,
			lt->tm_hour,lt->tm_min,lt->tm_sec,
			addmsg);
		write(fd, buff, strlen(buff));
		printf("%s\n", addmsg);
		fflush(stdout);
	}
	else {
		sprintf(buff,"%04d/%02d/%02d %02d:%02d:%02d %s(%d): %s\n", 
			lt->tm_year+1900,lt->tm_mon+1,lt->tm_mday,
			lt->tm_hour,lt->tm_min,lt->tm_sec,
			filename, line, addmsg);
		write(fd, buff, strlen(buff));
	}

	/* unlock log file */
    flock(fd, LOCK_UN);

	/* log file close */
	close(fd);
}
