/*
 * Copyright (c) 2000 S.Eguchi(fukurou@kissa.ne.jp)
 * All rights reserved.
 */
#include <stdio.h>
#include <errno.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/types.h>

#include "GetWUDirStatus.h"
#include "CheckMakeWUDir.h"
#include "Log.h"

#define SH_MAIN 
#include "GblArea.h"



int main(int argc, char* argv[]) 
{

	WU_DIR_STAT		wuStat;
	char			dirname[1024];
	char			setipath[1024];
	char			cwd[1024];
	int				i;
	int				pid;
	int				wpid;
	int				wstatus;
	int				execret;


    /* read configuration from file */
    if(ConfInit() != 0) {
        LOGOUT("Invalid configuration!! exit.");
        return(1);
    }

	InitGlobal();

	if(getcwd(cwd, sizeof(cwd)) == 0) {
		sprintf(g_msgWork, "Process execution error(%s)", strerror(errno));
		LOGOUT(g_msgWork);
		return(1);
	}

	if(CheckMakeWUDir(".", g_wuNum)!=0) {
		LOGOUT("Check & Make WU working dir error");
		return(1);
	}



	for(i=0;i<g_wuNum;i++) {
		sprintf(dirname, "%s/%s%03d", ".", WU_DIR_SUF, i);
		DBGOUT(dirname);

		wuStat = GetWUDirStat(dirname);

		switch(wuStat) {

    	case WU_DIR_STAT_EXECUTION: 
			sprintf(g_msgWork, "%s is executing other setiathome", dirname);
			LOGOUT(g_msgWork);
			break;

    	case WU_DIR_STAT_END: 		
    	case WU_DIR_STAT_NO_WU:     
			sprintf(g_msgWork, "%s is not found Working Unit", dirname);
			LOGOUT(g_msgWork);
			pid = fork();
			if(pid < 0) {
				sprintf(g_msgWork, "Process execution error(%s)", strerror(errno));
				LOGOUT(g_msgWork);
				return(1);
			}
			else if(pid == 0) {
				/* child process */
				sprintf(setipath, "%s/%s", cwd, SETI_MODULE_NAME);

				sprintf(g_msgWork, "SETI PATH = %s ",setipath);
				LOGOUT(g_msgWork);

				sprintf(g_msgWork, "Working Unit get start ");
				LOGOUT(g_msgWork);

				if(chdir(dirname) != 0) {
					sprintf(g_msgWork, "working directory error(%s)", strerror(errno));
					LOGOUT(g_msgWork);
					exit(1);
				}
				g_execArg[g_execArgNum] = SETP_STOP_AFT_XFER;
				g_execArg[g_execArgNum+1] = NULL;
				execret = execv(setipath, g_execArg);
				exit(execret);
			}
			else  {
				/* parent process */
				wpid = wait(&wstatus);
				if(WEXITSTATUS(wstatus) != 0) {
					sprintf(g_msgWork, "setiathome execution error rc=%d ", WEXITSTATUS(wstatus));
					LOGOUT(g_msgWork);
				}
			}
			break;

    	case WU_DIR_STAT_NO_DIR:    
    	case WU_DIR_STAT_ERR:       
		default: 
			sprintf(g_msgWork, "%s is error occurs", dirname);
			LOGOUT(g_msgWork);
			break;
		}
	}
	return(0);
}


